"{ Package: 'stx:goodies/libcairo' }"!

!Cairo class methodsFor:'accessing'!

libraryName

	OperatingSystem isUNIXlike ifTrue:[^'libcairo.so.2'].

	OperatingSystem isMSWINDOWSlike ifTrue:[^'cairo.dll'].

	self error:'Library name for host OS is not known'

    "Created: / 10-09-2008 / 19:29:18 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Cairo class methodsFor:'primitives'!

primDebugResetStaticData

	<cdecl: void "cairo_debug_reset_static_data" ( ) >
	self primitiveFailed

    "Created: / 10-09-2008 / 19:08:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Cairo class methodsFor:'primitives'!

primFormatStrideForWidth: format width: width

	<cdecl: int32 "cairo_format_stride_for_width" ( int32 int32 ) >
	self primitiveFailed

    "Created: / 10-09-2008 / 19:08:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Cairo class methodsFor:'primitives'!

primStatusToString: status

	<cdecl: charPointer "cairo_status_to_string" ( int32 ) >
	self primitiveFailed

    "Created: / 10-09-2008 / 19:08:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Cairo class methodsFor:'primitives'!

primVersion

	<cdecl: int32 "cairo_version" ( ) >
	self primitiveFailed

    "Created: / 10-09-2008 / 19:08:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Cairo class methodsFor:'primitives'!

primVersionString

	<cdecl: charPointer "cairo_version_string" ( ) >
	self primitiveFailed

    "Created: / 10-09-2008 / 19:08:50 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Cairo class methodsFor:'accessing'!

statusToString: status

    ^self primStatusToString: status

    "Created: / 10-09-2008 / 19:33:31 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Cairo class methodsFor:'accessing'!

version

    ^self primVersion

    "Created: / 10-09-2008 / 19:32:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!Cairo class methodsFor:'accessing'!

versionString

    ^self primVersionString

    "Created: / 10-09-2008 / 19:32:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!DeviceGraphicsContext methodsFor:'cairo support'!

drawableId

    ^drawableId

    "Created: / 10-07-2008 / 10:20:04 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!GraphicsDevice methodsFor:'cairo support'!

cairoSurfaceFor: view

    self error:'Graphics device not supported'

    "Created: / 10-07-2008 / 10:16:21 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!GraphicsDevice methodsFor:'accessing'!

displayId
    ^ displayId

    "Created: / 04-07-2008 / 12:58:56 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!SimpleView methodsFor:'cairo support'!

cairo
    ^ Cairo::GraphicsContext on:self cairoSurface

    "Created: / 10-09-2008 / 18:23:11 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!SimpleView methodsFor:'cairo support'!

cairoSurface

    ^Cairo::Surface forView: self

    "Created: / 10-07-2008 / 19:39:58 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!XWorkstation methodsFor:'cairo support'!

cairoSurfaceFor: view

    | surface |
    surface := Cairo::Surface
                forXlib: displayId
                drawable: view drawableId address
                visual: self defaultVisual
                width: view width
                height: view height.
    surface setView: view.
    "/view addDependent: surface.
    ^surface

    "Created: / 10-07-2008 / 10:16:36 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 09-09-2008 / 22:57:22 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 17-06-2012 / 15:05:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_goodies_libcairo class methodsFor:'documentation'!

extensionsVersion_SVN
    ^ '$Id::                                                                                                                        $'
! !